/*
 * Copyright (c) 2012 - 2013 Alexandre Tuleu
 *
 * This file is part of biorob-cpp.
 *
 *   biorob-cpp is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as
 *   published by the Free Software Foundation, either version 3 of the
 *   License, or (at your option) any later version.
 *
 *   biorob-cpp is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of both the GNU General Public
 *   License AND GNU Lesser General Public License along with
 *   biorob-cpp.  If not, see <http://www.gnu.org/licenses/>.
 */


/*
 * Copyright (c) 2012  Alexandre Tuleu
 *
 * This file is part of biorob-cpp.
 *
 *   biorob-cpp is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as
 *   published by the Free Software Foundation, either version 3 of the
 *   License, or (at your option) any later version.
 *
 *   biorob-cpp is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of both the GNU General Public
 *   License AND GNU Lesser General Public License along with
 *   PROJECT.  If not, see <http://www.gnu.org/licenses/>.
 */


/**
 * \file Widget.h
 *
 *  \date Oct 24, 2012
 *  \author Alexandre Tuleu
 */

#ifndef BIOROB_CLI_WIDGET_H_
#define BIOROB_CLI_WIDGET_H_

#include <tr1/memory>
#include <string>

#include <ncurses.h>

#include <biorob-cpp/base/common.h>

namespace cli {

/**
 *
 */
class Widget {
	DISABLE_COPY(Widget)
public:
	typedef std::tr1::shared_ptr<Widget> Ptr;
	struct Def{
		Def();
		int x;
		int y;
		int height;
		int width;
		std::string title;
	};
	Widget(const Def & def);
	virtual ~Widget();

	std::size_t Width();
	std::size_t Height();
protected :
	WINDOW * Window();
private :
	void operator=(const Widget & src); //UNDEFINED
	void SetTitle(const std::string & title);


	WINDOW * d_window, * d_titleWindow;
	std::size_t d_width;
	std::size_t d_height;
};

inline WINDOW * Widget::Window(){
	return d_window;
}


}
std::ostream & operator << (std::ostream & out, const cli::Widget::Def & def);
#endif // BIOROB_CLI_WIDGET_H_
