/*
 * Copyright (c) 2012 - 2013 Alexandre Tuleu
 *
 * This file is part of biorob-cpp.
 *
 *   biorob-cpp is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as
 *   published by the Free Software Foundation, either version 3 of the
 *   License, or (at your option) any later version.
 *
 *   biorob-cpp is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of both the GNU General Public
 *   License AND GNU Lesser General Public License along with
 *   biorob-cpp.  If not, see <http://www.gnu.org/licenses/>.
 */


/**
 * PluginLoader.cpp
 *
 *  Created on: 6 nov. 2012
 *      Author: akay
 */

#include "PluginLoader.h"

#include <biorob-cpp/config.h>

#ifdef BIOROB_CPP_Linux
const char * PluginLoaderBase::SharedLibPrefix = "lib";

const char * PluginLoaderBase::SharedLibSuffix = ".so";

const char * PluginLoaderBase::CMakeModulePrefix = "lib";

const char * PluginLoaderBase::CMakeModuleSuffix = ".so";
#endif //BIOROB_CPP_Linux

#ifdef BIOROB_CPP_Darwin
const char * PluginLoaderBase::SharedLibPrefix = "lib";

const char * PluginLoaderBase::SharedLibSuffix = ".dylib";

const char * PluginLoaderBase::CMakeModulePrefix = "lib";

const char * PluginLoaderBase::CMakeModuleSuffix = ".so";
#endif //BIOROB_CPP_Darwin


#ifdef BIOROB_CPP_Windows
const char * PluginLoaderBase::SharedLibPrefix = "";

const char * PluginLoaderBase::SharedLibSuffix = ".dll";

const char * PluginLoaderBase::CMakeModulePrefix = "lib";

const char * PluginLoaderBase::CMakeModuleSuffix = ".so";
#endif //BIOROB_CPP_Windows
