/*
 * Copyright (c) 2012 - 2013 Alexandre Tuleu
 *
 * This file is part of biorob-cpp.
 *
 *   biorob-cpp is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as
 *   published by the Free Software Foundation, either version 3 of the
 *   License, or (at your option) any later version.
 *
 *   biorob-cpp is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of both the GNU General Public
 *   License AND GNU Lesser General Public License along with
 *   biorob-cpp.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef BIOROB_CPP_STATIC_CAN_CALL:STATIC_METHOD_H_
#define BIOROB_CPP_STATIC_CAN_CALL_STATIC_METHOD_H_

#ifdef CAN_CALL_STATIC_METHOD
#error //macro CAN_CALL_STATIC_METHOD already defined
#endif

#ifdef DEFINE_CAN_CALL_STATIC_METHOD
#error //macro DEFINE_CAN_CALL_STATIC_METHOD already defined
#endif

#define DEFINE_CAN_CALL_STATIC_METHOD(MethodName)\
namespace biorobcpp {\
	namespace CanCallStaticMethod {\
		template <typename Class, bool > \
		class Caller##MethodName{ \
		public :\
			static void call() { /* do nothin */ }\
		};\
		template <typename Class>\
		class Caller ## MethodName<Class,true>{    \
		public :\
			static void call(){ Class::MethodName(); };      \
		};\
		\
		template <typename Class>\
		class CanCallStatic ## MethodName{\
		public :\
			static void call();\
		private :\
			typedef char yes;\
			typedef struct{char d_dummy[2];} no;\
			\
			template <typename Caller>\
			static yes Test(typeof(&Caller::MethodName));\
			\
			template <typename Caller>\
			static no Test(...);\
		public :\
			static const bool value = sizeof(Test<Class>(0)) == sizeof(yes);\
		};\
		\
		template <typename Class>\
		void CanCallStatic ## MethodName<Class>::call(){ Caller ##MethodName<Class,value>::call(); }\
	}\
}

#define CAN_CALL_STATIC_METHOD(ClassName,MethodName) CanCallStaticMethod::CanCallStatic ## MethodName<ClassName>

#endif //BIOROB_CPP_STATIC_CAN_CALL:STATIC_METHOD_H_
